<template>
  <Row class="stoker-note-detail">
    <i-col :lg="{ offset: 6, span: 12 }" :md="{ offset: 6, span: 12 }">
      <!-- create -->
      <Row v-if="isCreate">
        <input class="title-input inline-block" v-model="title" placeholder="Title..."></input>

        <div class="quill-editor"
             v-model="content"
             v-quill:myQuillEditor="editorOption">
        </div>

        <Row class="tool-block">
          <div class="literal-div-btn cancel-btn" @click="redirectAction('list')"> Cancel </div>
          <div class="literal-div-btn submit-btn" @click="submitAction"> Submit </div>
        </Row>
      </Row>
      <!-- edit -->
      <Row v-else-if="isEdit">
        <input class="title-input inline-block" v-model="title" placeholder="Title..."></input>

        <div class="quill-editor"
             v-model="content"
             v-quill:myQuillEditor="editorOption">
        </div>

        <Row class="tool-block">
          <div class="literal-div-btn cancel-btn" @click="redirectAction('list')"> Cancel </div>
          <div class="literal-div-btn submit-btn" @click="updateAction"> Update </div>
        </Row>
      </Row>
      <!-- view -->
      <Row v-else-if="isView">
        <div class="note-date">{{date}}</div>
        <div class="note-title">{{title}}</div>
        <div class="note-content">
          <div v-html="content"></div>
        </div>
        <Row class="tool-block">
          <div class="literal-div-btn back-btn" @click="redirectAction('list')"> Back </div>
          <div class="literal-div-btn new-note-btn" @click="redirectAction('create')"> New Note </div>
          <div class="literal-div-btn edit-btn" @click="redirectAction('edit')"> Edit </div>
        </Row>
      </Row>
    </i-col>
  </Row>
</template>

<script>
import { todayLocaleString } from '../../../../../helpers/utils';
import { validators as api } from '../../../../../configs/request-validator/note';

const actions = {
  async submitAction() {
    const requestData = {
      title: this.title,
      content: this.content,
      date: todayLocaleString(),
    };

    try {
      await this.$api(api.CreateNoteRequest, requestData);
      this.$redirectTo('investor-note');
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
  async updateAction() {
    const requestData = {
      title: this.title,
      content: this.content,
      noteId: this.noteId,
    };

    try {
      await this.$api(api.UpdateNoteRequest, requestData);
      this.$redirectTo('investor-note');
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
  redirectAction(type) {
    let name = 'investor-note-id-type';
    let params = { type };
    switch (type) {
      case 'edit':
        params.id = this.noteId.toString();
        break;
      case 'create':
        params.id = '-1';
        break;
      case 'list':
        name = 'investor-note';
        params = undefined;
        break;
    }
    this.$redirectTo(name, params);
  },
};

export default {
  name: 'index',
  data() {
    return {
      // server side
      title: undefined,
      content: undefined,
      date: undefined,
      editorOption: {
        modules: {
          toolbar: [
            ['bold', 'italic', 'underline', 'strike'],
            [{ 'list': 'ordered'}, { 'list': 'bullet' }],
            [{ 'indent': '-1'}, { 'indent': '+1' }],
          ]
        }
      },
      timestamp: new Date().getTime(),
    };
  },
  computed: {
    noteId() {
      return Number(this.$route.params['id']);
    },
    type() {
      return this.$route.params['type'];
    },
    isCreate() {
      return this.noteId === -1 && this.type === 'create';
    },
    isEdit() {
      return this.noteId > 0 && this.type === 'edit';
    },
    isView() {
      return this.noteId > 0 && this.type === 'view';
    },
  },
  watch: {
    isCreate() {
      if (this.isCreate) {
        this.title = undefined;
        this.content = "";
        this.date = undefined;
      }
    }
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({app, params, redirect}) {
    const noteId = Number(params['id']);
    const type = params['type'];
    const isCreate = noteId === -1 && type === 'create';
    const isEdit = noteId > 0 && type === 'edit';
    const isView = noteId > 0 && type === 'view';
    const isErrorType = !(isCreate || isEdit || isView);
    if (isErrorType) {
      redirect('/investor/note');
    }

    let title = undefined;
    let content = undefined;
    let date = undefined;
    const toLoadNoteData = isEdit || isView;
    if (toLoadNoteData) {
      // request
      const noteRequestData = { noteId };

      try {
        // invoke api
        const responseData = await Promise.all([
          app.$api(api.AccessNoteByIdRequest, noteRequestData, undefined, false),
        ]);

        // set vue value
        title = responseData[0]['data']['title'];
        content = responseData[0]['data']['content'];
        date = (new Date(responseData[0]['data']['timestamp'])).toLocaleDateString();
      } catch (error) {
        app.$apiErrorHandler(error);
      }
    }

    return {
      title, content, date,
    };
  }
}
</script>

<style lang="scss" scoped>
  @import '../../../../../assets/css/mixin';

  .stoker-note-detail {
    height: 100%;
    padding: 100px 0 0 0;
    overflow-y: auto;
    .title-input {
      width: 100%;
      height: 40px;
      padding: 15px;
      border-radius: 10px;
      border: 1.5px solid;
      margin: 25px 0;
      font-size: 20px;
      vertical-align: bottom;
      &:focus {
        outline: none;
      }
    }
    .quill-editor {
      min-height: 300px;
    }
    .tool-block {
      padding: 30px 0;
    }
    .note-date {
      font-size: 18px;
      font-weight: bold;
    }
    .note-title {
      width: 100%;
      height: 40px;
      padding: 0 15px;
      border-radius: 8px;
      border: 1.5px solid;
      margin: 25px 0;
      font-size: 20px;
      line-height: 40px;
      vertical-align: middle;
    }
    .note-content {
      width: 100%;
      min-height: 300px;
      padding: 10px 15px;
      border-radius: 8px;
      border: 1px solid;
      font-size: 18px;
    }
  }
</style>

<style lang="scss">
  .ql-toolbar {
    border-top-left-radius: 10px;
    border-top-right-radius: 10px;
  }
  .ql-container.ql-snow {
    border-bottom-left-radius: 10px;
    border-bottom-right-radius: 10px;
    font-size: 18px;
  }
  .note-content {
    ol, ul {
      padding: 0 30px;
    }
  }
</style>
